aboutsummaryrefslogtreecommitdiffstats
path: root/make/cross_check_erl
diff options
context:
space:
mode:
authorRickard Green <[email protected]>2010-02-03 12:56:25 +0000
committerErlang/OTP <[email protected]>2010-02-03 19:04:55 +0100
commit1b78e85c9b6097f0d1940793e5fed4e08c0794f9 (patch)
tree10ede523234396673be3a77a8d5dbdee20dee696 /make/cross_check_erl
parent639e0b2ac0fb85335511efcf79327d1f4dfacbc3 (diff)
downloadotp-1b78e85c9b6097f0d1940793e5fed4e08c0794f9.tar.gz
otp-1b78e85c9b6097f0d1940793e5fed4e08c0794f9.tar.bz2
otp-1b78e85c9b6097f0d1940793e5fed4e08c0794f9.zip
OTP-8323 Cross compilation improvements and other build system
improvements. Most notable: Lots of cross compilation improvements. The old cross compilation support was more or less non-existing as well as broken. Please, note that the cross compilation support should still be considered as experimental. Also note that old cross compilation configurations cannot be used without modifications. For more information on cross compiling Erlang/OTP see the $ERL_TOP/xcomp/README file. Support for staged install using <url href="http://www.gnu.org/prep/standards/html_node/DESTDIR.html">D ESTDIR</url>. The old broken INSTALL_PREFIX has also been fixed. For more information see the $ERL_TOP/README file. Documentation of the release target of the top Makefile. For more information see the $ERL_TOP/README file. make install now by default creates relative symbolic links instead of absolute ones. For more information see the $ERL_TOP/README file. $ERL_TOP/configure --help=recursive now works and prints help for all applications with configure scripts. Doing make install, or make release directly after make all no longer triggers miscellaneous rebuilds. Existing bootstrap system is now used when doing make install, or make release without a preceding make all. The crypto and ssl applications use the same runtime library path when dynamically linking against libssl.so and libcrypto.so. The runtime library search path has also been extended. The configure scripts of erl_interface and odbc now search for thread libraries and thread library quirks the same way as erts do. The configure script of the odbc application now also looks for odbc libraries in lib64 and lib/64 directories when building on a 64-bit system. The config.h.in file in the erl_interface application is now automatically generated in instead of statically updated which reduces the risk of configure tests without any effect.
Diffstat (limited to 'make/cross_check_erl')
-rwxr-xr-xmake/cross_check_erl147
1 files changed, 147 insertions, 0 deletions
diff --git a/make/cross_check_erl b/make/cross_check_erl
new file mode 100755
index 0000000000..cb9dadfb32
--- /dev/null
+++ b/make/cross_check_erl
@@ -0,0 +1,147 @@
+#!/bin/sh
+#
+# %CopyrightBegin%
+#
+# Copyright Ericsson AB 2010. All Rights Reserved.
+#
+# The contents of this file are subject to the Erlang Public License,
+# Version 1.1, (the "License"); you may not use this file except in
+# compliance with the License. You should have received a copy of the
+# Erlang Public License along with this software. If not, it can be
+# retrieved online at http://www.erlang.org/.
+#
+# Software distributed under the License is distributed on an "AS IS"
+# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
+# the License for the specific language governing rights and limitations
+# under the License.
+#
+# %CopyrightEnd%
+#
+# Author: Rickard Green
+#
+
+target=
+build_otp=
+erl_top=
+force=no
+
+while [ $# -gt 0 ]; do
+ case "$1" in
+ -target)
+ shift
+ test $# -gt 0 || { echo "$0: Missing target" 1>&2; exit 1; }
+ target="$1";;
+ -otp)
+ shift
+ test $# -gt 0 || { echo "$0: Missing otp release" 1>&2; exit 1; }
+ build_otp="$1";;
+ -erl_top)
+ shift
+ test $# -gt 0 || { echo "$0: Missing erl top" 1>&2; exit 1; }
+ erl_top="$1";;
+ -force)
+ shift
+ test $# -gt 0 || { echo "$0: Missing force value" 1>&2; exit 1; }
+ force=$1;;
+ *)
+ echo "$0: Bad argument: $1" 1>&2
+ exit 1;;
+ esac
+ shift
+done
+
+test "X$target" != "X" || { echo "$0: Missing target" 1>&2; exit 1; }
+test "X$build_otp" != "X" || { echo "$0: Missing otp release" 1>&2; exit 1; }
+test "X$erl_top" != "X" || { echo "$0: Missing erl top" 1>&2; exit 1; }
+test "X$force" != "X" || { echo "$0: Missing force value" 1>&2; exit 1; }
+
+cd $erl_top
+
+cat > cross_check_erl.erl <<\EOF
+%
+% Copyright Ericsson AB 2010. All Rights Reserved.
+%
+% The contents of this file are subject to the Erlang Public License,
+% Version 1.1, (the "License"); you may not use this file except in
+% compliance with the License. You should have received a copy of the
+% Erlang Public License along with this software. If not, it can be
+% retrieved online at http://www.erlang.org/.
+%
+% Software distributed under the License is distributed on an "AS IS"
+% basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
+% the License for the specific language governing rights and limitations
+% under the License.
+%
+
+-module(cross_check_erl).
+
+-export([start/0]).
+
+start() ->
+ OTP = case catch erlang:system_info(otp_release) of
+ {'EXIT', _} -> "OTP";
+ Rel -> "OTP-" ++ Rel
+ end,
+ io:format("~s~n", [OTP]),
+ init:stop().
+
+EOF
+
+erlc cross_check_erl.erl 2>/dev/null \
+ && used_otp=`erl -noshell -noinput -pa . -run cross_check_erl 2>/dev/null`
+
+res=$?
+
+rm -f cross_check_erl.erl cross_check_erl.beam
+
+test $res -eq 0 || {
+ cat 1>&2 <<EOF
+* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
+* ERROR: No usable Erlang/OTP system for the build machine found! Cannot
+* cross compile without such a system.
+*
+* Either build a bootstrap system for the build machine, or provide
+* an Erlang/$build_otp system in the \$PATH, and try again. For more
+* information on cross compiling Erlang/$build_otp, see the
+* \$ERL_TOP/xcomp/README file.
+* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
+EOF
+ exit 1
+}
+
+test "X$build_otp" = "X$used_otp" || {
+ test $force = yes || {
+ cat 1>&2 <<EOF
+* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
+* ERROR: Trying to cross compile an Erlang/$build_otp system with a different
+* Erlang/$used_otp system. When cross compiling you should compile
+* with an Erlang/OTP system of the same release. It is possible,
+* however not recomended, to force the cross compilation even though
+* the wrong Erlang/OTP system is used. For more information on this,
+* and cross compiling Erlang/$build_otp in general, see the
+* \$ERL_TOP/xcomp/README file.
+* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
+EOF
+ exit 1
+ }
+
+ cat <<EOF
+* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
+* WARNING: Cross compiling an Erlang/$build_otp system with a different
+* Erlang/$used_otp system. When cross compiling you should compile
+* with an Erlang/OTP system of the same release. This build might
+* fail, or silently produce suboptimal code. For more information on
+* cross compiling Erlang/$build_otp, see the \$ERL_TOP/xcomp/README
+* file.
+* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
+
+EOF
+}
+
+cat <<EOF
+*
+* Cross compiling Erlang/$build_otp for: $target
+*
+EOF
+
+exit 0